/*
 *	binkleyforce -- unix FTN mailer project
 *	
 *	Copyright (c) 1998-2000 Alexander Belkin, 2:5020/1398.11
 *	
 *	This program is free software; you can redistribute it and/or modify
 *	it under the terms of the GNU General Public License as published by
 *	the Free Software Foundation; either version 2 of the License, or
 *	(at your option) any later version.
 *	
 *	$Id: prot_binkp.h,v 1.2 2000/06/25 19:49:29 adb Exp $
 *
 *	binkp's frames:
 *	
 *	  +---------------------- 0=data block, 1=message(command)
 *	  |                +---- data block size / msg's argument size
 *	  |                |
 *	  7  6543210 76543210
 *	 +-+-------+--------+--- ... ---+
 *	 | |   HI      LO   |           | -- data block / msg's argument
 *	 +-+-------+--------+--- ... ---+
 */

#ifndef _P_BINKP_H_
#define _P_BINKP_H_

#define BINKP_NAME		"binkp"
#define BINKP_MAJOR		1
#define BINKP_MINOR		0
#define BINKP_PORT		24554
#define BINKP_TIMEOUT		(5*60)
#define BINKP_MIN_BLKSIZE 	128
#define BINKP_MAX_BLKSIZE	0x7fff
#define BINKP_DEF_BLKSIZE	(4*1024u)
#define BINKP_BLK_HDRSIZE	2

#define BINKP_MAXPASSWD		40
#define BINKP_MAXSYSTNAME	120
#define BINKP_MAXLOCATION	120
#define BINKP_MAXSYSOP		120
#define BINKP_MAXPHONE		120
#define BINKP_MAXFLAGS		120
#define BINKP_MAXLOCATION	120
#define BINKP_MAXPROGNAME	40
#define BINKP_MAXPROTNAME	40
#define BINKP_MAXTIMESTR	40

typedef struct {
	s_sysaddr *addrs;
	int        anum;
	char       passwd[BINKP_MAXPASSWD+1];
	char       systname[BINKP_MAXSYSTNAME+1];
	char       location[BINKP_MAXLOCATION+1];
	char       sysop[BINKP_MAXSYSOP+1];
	char       phone[BINKP_MAXPHONE+1];
	char       flags[BINKP_MAXFLAGS+1];
	char       progname[BINKP_MAXPROGNAME+1];
	char       protname[BINKP_MAXPROTNAME+1];
	char       timestr[BINKP_MAXTIMESTR+1];
	int        majorver;
	int        minorver;
} s_binkp;

int binkp_session(s_protinfo *pi);

#endif /* _P_BINKP_H_ */
